<script lang="ts">
    import type Research from '$models/Research'
    import { onMount } from 'svelte'
    import getHumanName from '$utils/getHumanName'
    export let research: Research

    let svg: SVGElement

    const drawLinks = () => {
        if (research.ref && svg) {
            svg.innerHTML = ''
            const parentRect = research.ref.getBoundingClientRect()
            research.unlocks.forEach((unlock: Research) => {
                const childRect = unlock.ref.getBoundingClientRect()

                const link = document.createElementNS('http://www.w3.org/2000/svg', 'line')
                link.setAttribute('x1', String(parentRect.width - 10))
                link.setAttribute('y1', String(-parentRect.height / 2 + 4))
                link.setAttribute('x2', String(childRect.left - parentRect.left))
                link.setAttribute(
                    'y2',
                    String(
                        childRect.top +
                            childRect.height / 2 -
                            (parentRect.top + parentRect.height / 2) -
                            childRect.height / 2 +
                            4
                    )
                )

                if (unlock.unlocked || !research.parent || research.parent?.unlocked) {
                    link.setAttribute(
                        'class',
                        'text-trueGray-800 dark:text-trueGray-100 stroke-current'
                    )
                } else {
                    link.setAttribute(
                        'class',
                        'text-trueGray-200 dark:text-trueGray-700 stroke-current'
                    )
                }
                link.setAttribute('stroke-width', '4')
                svg.append(link)
            })
        }
    }

    onMount(() => {
        if (research?.ref) {
            drawLinks()
        }
    })

    const unlock = () => {
        if (!research.parent || research.parent?.unlocked) {
            research.unlock().then(() => (research = research))
        }
    }
</script>

<svelte:window on:resize={drawLinks} />

<div
    class:unlocked={research.unlocked}
    class:unavailable={research.parent && !research.parent?.unlocked}
    id="research-{research.id}"
    bind:this={research.ref}
    on:click={unlock}
>
    <h3 class="name">{getHumanName(research.name)}</h3>
    <div class="costs">
        <dl>
            <dt>Elerium</dt>
            <dd>{research.needed_elerium}</dd>
        </dl>
        <dl>
            <dt>Research</dt>
            <dd>{research.needed_science}</dd>
        </dl>
    </div>
    <svg width="0" height="0" bind:this={svg} />
</div>

<style lang="postcss">
    div[id^='research'] {
        @apply relative bg-gray-200 dark:bg-trueGray-900 py-1 px-2 rounded-md cursor-pointer;

        &.unlocked {
            @apply bg-gradient-to-r from-fuchsia-200 to-indigo-200 dark:from-fuchsia-800 dark:to-indigo-800;

            dt {
                @apply !text-fuchsia-400;
            }
        }

        &.unavailable {
            @apply cursor-not-allowed;

            &::after {
                @apply content-[''] absolute inset-0 bg-trueGray-100/70 dark:bg-trueGray-900/70;
            }
        }

        h3 {
            @apply font-semibold text-lg leading-snug mb-1 text-trueGray-800 dark:text-trueGray-50;
        }

        .costs {
            @apply flex gap-x-4;

            dl {
                @apply w-1/2 text-trueGray-800 dark:text-trueGray-50;

                dt {
                    @apply whitespace-nowrap font-semibold text-trueGray-500 dark:text-trueGray-400;
                }
            }
        }

        svg {
            @apply overflow-visible relative z-[-1];
        }
    }
</style>
